unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Button5: TButton;
    Button3: TButton;
    Button2: TButton;
    Button4: TButton;
    Button7: TButton;
    Button6: TButton;
    Button8: TButton;
    OpenDialog1: TOpenDialog;
    Button9: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses VBScript_RegExp_55_TLB, RegExpr;

{$R *.dfm}

const
  sResWords =
    '\b(and|array|as|asm|begin|case|class|const|constructor|destructor|dispinterface|div|do|' +
    'downto|else|end|except|exports|file|finalization|finally|for|function|goto|if|implementation|' +
    'in|inherited|initialization|inline|interface|is|label|library|mod|nil|not|object|of|' +
    'or|out|packed|private|procedure|program|property|protected|public|published|raise|record|' +
    'repeat|resourcestring|set|shl|shr|string|then|threadvar|to|try|type|unit|until|uses|var|' +
    'while|with|xor)\b';
  sString = '(\x27[^\x27]*\x27|#\d{1,3}|#\$[0-9][0-9a-f])';
  sComment = '(\{.*?\}|\(\*.*?\*\)|//[^\n\r]*)';

function HtmlSpecialChars(const S: String): String;
begin //  ""  html...
  //  & -   !!!
  Result := StringReplace(Result, '&', '&amp;', [rfReplaceAll]);
  //  <
  Result := StringReplace(TrimRight(S), '<', '&lt;', [rfReplaceAll]);
  //  >
  Result := StringReplace(Result, '>', '&gt;', [rfReplaceAll]);
  //  "
  Result := StringReplace(Result, '"', '&quot;', [rfReplaceAll]);
end;

procedure TForm1.Button1Click(Sender: TObject);
// http://msdn.microsoft.com/library/en-us/dnclinic/html/scripting051099.asp?frame=true
var
  R: TRegExp;
  mc: MatchCollection;
  m: Match;
  sm: SubMatches;
  i, j: Integer;
begin
  R := TRegExp.Create(Self);
  try
    R.Pattern := Edit1.Text;
    R.IgnoreCase := True;
    R.Global := True;
    Memo1.Lines.Clear;
    mc := R.Execute(Edit2.Text) as MatchCollection;
    if mc.Count > 0 then begin
      for i := 0 to mc.Count - 1 do begin
        m := mc[i] as Match;
        Memo1.Lines.Add(Format('Match[%d] = "%s"', [i, m.Value]));
        sm := m.SubMatches as SubMatches;
        for j := 0 to sm.Count - 1 do
          Memo1.Lines.Add(Format('  SubMatch[%d] = "%s"', [j, VarToStr(sm[j])]));
      end;
    end;
  finally
    m := nil;
    sm := nil;
    mc := nil;
    R.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
// http://www.regular-expressions.info/floatingpoint.html
var
  mc: MatchCollection;
  S: String;
begin
  with TRegExp.Create(Self) do
  try
    Pattern := Format('[-+]?([0-9]*\%s)?[0-9]+([eE][-+]?[0-9]+)?', [DecimalSeparator]);
    IgnoreCase := True;
    Global := True;
    Multiline := True;
    S := '';
    mc := Execute('5.23') as MatchCollection;
    if mc.Count = 1
      then ShowMessageFmt(' "%s"  ', [(mc[0] as Match).Value])
      else ShowMessage('  !');
  finally
    mc := nil;
    Free;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
// http://www.regular-expressions.info/dates.html

  function IsValidDate(const ADate: String): Boolean;
  var
    mc: MatchCollection;
    sm: SubMatches;
    d, m, y: Integer;
  begin
    Result := False;
    with TRegExp.Create(Self) do
    try
      Pattern := Format('(0?[1-9]|[12][0-9]|3[01])\%0:s(0?[1-9]|1[012])\%0:s((19|20)?\d\d)',
        [DateSeparator]);
      Global := True;
      MultiLine := True;
      mc := Execute(ADate) as MatchCollection;
      if mc.Count = 1 then begin
        sm := (mc[0] as Match).SubMatches as SubMatches;
        if sm.Count < 3 then Exit; //   !
        d := StrToInt(sm.Item[0]);
        m := StrToInt(sm.Item[1]);
        y := StrToInt(sm.Item[2]);
        if sm.Item[3] = '' then y := y +
          Trunc(StrToInt(FormatDateTime('yyyy', Date)) / 100) * 100;
        if (d = 31) and ((m = 4) or (m = 6) or (m = 9) or (m = 11))
          then Exit // 31-     30- 
          else
            if m = 2 then begin //   
              if d >= 30 then Exit; //   30   31 
              if (d = 29) and not ((y mod 4 = 0) and ((y mod 100 <> 0) or (y mod 400 = 0)))
                then Exit; // 29     
            end;
        Result := True; //  
      end;
    finally
      sm := nil;
      mc := nil;
      Free;
    end;
  end;

begin
  if IsValidDate('29.02.2004') then ShowMessage('OK') else Beep;
end;

procedure TForm1.Button4Click(Sender: TObject);
// http://www.regular-expressions.info/duplicatelines.html
var
  R: TRegExp;
begin
  R := TRegExp.Create(Self);
  try
    R.Pattern := '([^,]*)(,\1)+(?=,|$)';
    R.IgnoreCase := True;
    R.Global := True;
    R.Multiline := True;
    ShowMessage(R.Replace(',,,,,,,,,,'#10 +
      '1,2,3,3,4,5,5,6,7,,9', '$1'));
  finally
    R.Free;
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
// http://msdn.microsoft.com/library/en-us/dnclinic/html/scripting051099.asp?frame=true
var
  R: TRegExp;
begin
  R := TRegExp.Create(Self);
  try
    R.Pattern := '([a-z-]+) \1';
    R.IgnoreCase := True;
    R.Global := True;
    R.Multiline := True;
    ShowMessage(R.Replace('      ?'#10 +
      'Is is the cost of of gasoline going up up?', '$1'));
  finally
    R.Free;
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  S: String;
  Matches: MatchCollection;
  i: Integer;
begin
  S := 'c:\doc\doc1\doc2\test.doc';
  with TRegExp.Create(Self) do
  try
    Pattern := '\w:\\?|[^\\]+';
    IgnoreCase := True;
    Global := True;
    Matches := Execute(S) as MatchCollection;
    if Matches.Count > 0 then
      for i := 0 to Matches.Count - 1 do
        S := S + #10 + (Matches[i] as Match).Value;
    ShowMessage(S);
  finally
    Free;
  end;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  R: TRegExp;
  mc: MatchCollection;
  m: Match;
  sm: SubMatches;
  i, j: Integer;
  S: String;
begin
  R := TRegExp.Create(Self);
  try
    R.Pattern := '(\d*)\.?(\d*)';
    R.IgnoreCase := True;
    R.Global := False;
    S := Format('Pattern = "%s"', [R.Pattern]);
    mc := R.Execute('123.45') as MatchCollection;
    if mc.Count > 0 then begin
      for i := 0 to mc.Count - 1 do begin
        m := mc[i] as Match;
        S := S + Format(#10'Match[%d] = "%s"', [i, m.Value]);
        sm := m.SubMatches as SubMatches;
        for j := 0 to sm.Count - 1 do
          S := S + Format(#10#9'SumMatch[%d] = "%s"', [j, VarToStr(sm[j])]);
      end;
    end;
    ShowMessage(S);
  finally
    m := nil;
    sm := nil;
    mc := nil;
    R.Free;
  end;
end;

procedure TForm1.Button8Click(Sender: TObject);
// Microsoft VBScript RegExp
//  pas   html ( :
// , ,  )
var
  Src: TStringList;
  R: TRegExp;
  i: Integer;
  T: Cardinal;

  //        
  // 
  function ProcessStr(const S, ReplaceStr: String): String;
  var
    R2: TRegExp;
    mc: MatchCollection;
    j, P: Integer;
  begin
    R2 := TRegExp.Create(Self);
    try
      R2.Pattern := '\<([\w\d]+)[^>]*\>.*?\</\1\>';
      R2.Global := True;
      mc := R2.Execute(S) as MatchCollection;
      P := 1;
      Result := '';
      if mc.Count > 0 then begin
        for j := 0 to mc.Count - 1 do begin
          if (mc[j] as Match).FirstIndex = 1 then begin
            P := (mc[j] as Match).Length + 1;
            Result := (mc[j] as Match).Value;
          end else begin
            Result := Result + R.Replace(Copy(S, P, (mc[j] as Match).FirstIndex - P + 1),
              ReplaceStr) + (mc[j] as Match).Value;
            P := (mc[j] as Match).FirstIndex + (mc[j] as Match).Length + 1;
          end;
        end;
        if P <= Length(S)
          then Result := Result + R.Replace(Copy(S, P, Length(S) - P + 1), ReplaceStr);
      end
      else
        Result := R.Replace(S, ReplaceStr);
    finally
      mc := nil;
      R2.Free;
    end;
  end;

begin
  with OpenDialog1 do begin
    if Execute then begin
      Src := TStringList.Create;
      R := TRegExp.Create(Self);
      try
        R.IgnoreCase := True;
        R.Global := True;
        R.Multiline := True;
        Src.LoadFromFile(FileName);
        Src.Text := HtmlSpecialChars(Src.Text);

        //   
        T := GetTickCount;

        // 
        R.Pattern := sString;
        Src.Text := R.Replace(Src.Text, '<span style="color: #0000ff">$1</span>');
        // 
        R.Pattern := sComment;
        Src.Text := R.Replace(Src.Text, '<em style="color: #000099">$1</em>');

        ShowMessageFmt('   %d ', [GetTickCount - T]);

        //   
        T := GetTickCount;

        R.Multiline := False;
        for i := 0 to Src.Count - 1 do begin
          //  
          R.Pattern := sResWords;
          Src[i] := ProcessStr(Src[i], '<b>$1</b>');
        end;
        ShowMessageFmt('      RegExp  %d ',
          [GetTickCount - T]);

        Src.Insert(0, '<html><body><pre><code style=''font-family: "courier"; font-size: 9pt;''>');
        Src.Add('</code></pre></body></html>');
        Src.SaveToFile(ExtractFilePath(ParamStr(0)) + '\Test.html');
        Memo1.Lines.Assign(Src);

      finally
        Src.Free;
        R.Free;
      end;
    end;
  end;
end;

procedure TForm1.Button9Click(Sender: TObject);
// TRegExpr   http://regexpstudio.com/
//  pas   html ( :
// , ,  )
var
  Src: TStringList;
  R: TRegExpr;
  i: Integer;
  T: Cardinal;

  //        
  // 
  function ProcessStr(const S, ReplaceStr: String): String;
  var
    R2: TRegExpr;
    P: Integer;
  begin
    R2 := TRegExpr.Create;
    try
      R2.Expression := '\<([\w\d]+)[^>]*\>.*?\</\1\>';
      R2.ModifierG := True;
      if R2.Exec(S) then begin
        P := 1;
        Result := '';
        repeat
          if R2.MatchPos[0] = 1 then begin
            P := R2.MatchLen[0];
            Result := R2.Match[0];
          end
          else begin
            Result := Result + R.Replace(Copy(S, P, R2.MatchPos[0] - P), ReplaceStr, True);
            Result := Result + R2.Match[0];
            P := R2.MatchPos[0] + R2.MatchLen[0];
          end;
        until not R2.ExecNext;
        if (P <= Length(S)) and (S[P] <> '>')
          then Result := Result + R.Replace(Copy(S, P, Length(S) - P + 1), ReplaceStr, True);
      end
      else
        Result := R.Replace(S, ReplaceStr, True);
    finally
      R2.Free;
    end;
  end;

begin
  with OpenDialog1 do begin
    if Execute then begin
      Src := TStringList.Create;
      R := TRegExpr.Create;
      try
        R.ModifierI := True;
        R.ModifierG := True;
        R.ModifierM := True;
        Src.LoadFromFile(FileName);
        Src.Text := HtmlSpecialChars(Src.Text);

        //   
        T := GetTickCount;

        // 
        R.Expression := sString;
        Src.Text := R.Replace(Src.Text, '<span style="color: #0000ff">$1</span>', True);
        // 
        R.Expression := sComment;
        Src.Text := R.Replace(Src.Text, '<em style="color: #000099">$1</em>', True);

        ShowMessageFmt('   %d ', [GetTickCount - T]);

        //   
        T := GetTickCount;

        R.ModifierM := False;
        R.Expression := sResWords;
        for i := 0 to Src.Count - 1 do begin
          //  
          Src[i] := ProcessStr(Src[i], '<b>$1</b>');
        end;
        ShowMessageFmt('      TRegExpr  %d ',
          [GetTickCount - T]);

        Src.Insert(0, '<html><body><pre><code style=''font-family: "courier"; font-size: 9pt;''>');
        Src.Add('</code></pre></body></html>');
        Src.SaveToFile(ExtractFilePath(ParamStr(0)) + '\Test.html');
        Memo1.Lines.Assign(Src);

      finally
        Src.Free;
        R.Free;
      end;
    end;
  end;
end;

end.
